#!/bin/bash
# Script un poco tosco pero funcional para descargar y compilar rapidamente un kernel linux.
# Ya mejoraré el script cuando esté funcionando bien
# Se recomienda usar primero en una máquina virtual y probar que todo va bien. Una máquina virtual con Debian 11.

# Instalamos dependencias
apt install -y wget xz-utils make gcc ncurses-dev flex bison devscripts bc rsync libelf-dev libssl-dev dwarves hwinfo

# Descargamos el kernel
kernelUrlXz="https://cdn.kernel.org/pub/linux/kernel/v5.x/linux-5.15.1.tar.xz"
wget "$kernelUrlXz"

# Descomprimimos el kernel
tar xfvJ linux-5.15.1.tar.xz

# Copiamos la configuración actual del kernel actual como base
cd linux-5.15.1
apt clean
apt autoclean
make clean && make mrproper
cp /boot/config-$(uname -r) ./.config

# Cargamos la configuración
make menuconfig

# Eliminamos la línea de CONFIG_SYSTEM_TRUSTED_KEYS
grep -i "CONFIG_SYSTEM_TRUSTED_KEYS" .config 
sed -i '/CONFIG_SYSTEM_TRUSTED_KEYS/d' .config

# Compilamos el kernel a la debian way creando varios .deb 
make -j$(nproc) deb-pkg clean LOCALVERSION="-fanta"
